/*
 * yasapi_player_write.c
 * Copyright (C) 2015 Peter Belkner <pbelkner@snafu.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yasapi.h>

#if defined (YASAPI_RESAMPLE) // {
///////////////////////////////////////////////////////////////////////////////
static int CreateDirect(Player *pPlayer, WAVEFORMATEX *pwfx)
{
  return 0;
}

static void DestroyDirect(Player *pPlayer)
{
}

static const WAVEFORMATEX *FormatDirect(const Player *pPlayer)
{
  return &pPlayer->wfxx.Format;
}

static SIZE_T WriteDirect(Player *pPlayer, LPSTR pData, SIZE_T dwSize)
{
  return PlayerWriteWait(pPlayer,pData,dwSize);
}

const PlayerWriteStrategy *PlayerWriteDirect(void)
{
  static PlayerWriteStrategy strategy;

  if (NULL==strategy.name) {
    strategy.name="direct";
    strategy.Create=CreateDirect;
    strategy.Destroy=DestroyDirect;
    strategy.Format=FormatDirect;
    strategy.Write=WriteDirect;
  }

  return &strategy;
}

///////////////////////////////////////////////////////////////////////////////
static int CreateIndirect(Player *pPlayer, WAVEFORMATEX *pwfx)
{
  return ResampleCreate(pPlayer,pwfx);
}

static void DestroyIndirect(Player *pPlayer)
{
  ResampleDestroy(&pPlayer->res);
}

static const WAVEFORMATEX *FormatIndirect(const Player *pPlayer)
{
  return pPlayer->res.pwfx;
}

static SIZE_T WriteIndirect(Player *pPlayer, LPSTR pData, SIZE_T dwSize)
{
  return ResampleWrite(&pPlayer->res,pData,dwSize);
}

const PlayerWriteStrategy *PlayerWriteIndirect(void)
{
  static PlayerWriteStrategy strategy;

  if (NULL==strategy.name) {
    strategy.name="indirect";
    strategy.Create=CreateIndirect;
    strategy.Destroy=DestroyIndirect;
    strategy.Format=FormatIndirect;
    strategy.Write=WriteIndirect;
  }

  return &strategy;
}
#endif // }
