/*
 * yasapi_util.c
 * Copyright (C) 2015 Peter Belkner <pbelkner@snafu.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yasapi.h>
#include <stdarg.h>

char *basename(char *s)
{
  char *p=s+strlen(s);

  while (s<p&&'/'!=p[-1]&&'\\'!=p[-1]&&':'!=p[-1])
    --p;

  return p;
}

#if ! defined (YASAPI_DEBUG) // {
int message(const char *format, ...)
{
  HWND hWnd=winampGetOutModule()->hMainWindow;
  va_list ap;
  char buf[128];

  va_start(ap,format);
  vsprintf(buf,format,ap);
  va_end(ap);

  return MessageBoxA(
    hWnd,                 // _In_opt_  HWND hWnd,
    buf,                  // _In_opt_  LPCTSTR lpText,
    "YASAPI Error",       // _In_opt_  LPCTSTR lpCaption,
    MB_OK|MB_ICONERROR    // _In_      UINT uType
  );

  return 0;
}
#endif // }
